#extension GL_OES_EGL_image_external : require
precision mediump float;
varying vec2 vTextureCoord;
uniform sampler2D sTexture;
uniform float width;
uniform float height;

uniform sampler2D uFrontTexture;
varying vec2 vAreaEffectTextureCoord;

/*
vec3 luminance( in vec3 color ) {
	vec3 color_out;
	color_out.r=  0.299 * color.r + 0.587 *color.g +0.114*color.b ;
	color_out.g = -0.1482 * color.r + (-0.2910) *color.g + 0.4392*color.b ;
	color_out.b =  0.4392 * color.r + (-0.3678) *color.g +(-0.0714)*color.b ;

	return color_out ;
}

*/





/*
void rgb2hsv( unsigned char *rgb,int rgbOff,unsigned short *hsv,int hsvOff)
{
    int iMin,iMax,chroma;
    int ABITS = 4;
    int HSCALE = 256;

    int k1=255 << ABITS;
    int k2=HSCALE << ABITS;

    int ri = rgb[rgbOff+0];
    int gi = rgb[rgbOff+1];
    int bi = rgb[rgbOff+2];
    short rv,rs,rh;

    if (ri > gi) {
        iMax = MAX (ri, bi);
        iMin = MIN (gi, bi);
    } else {
        iMax = MAX (gi, bi);
        iMin = MIN (ri, bi);
    }

    chroma = iMax - iMin;
    // set value
    rv = (short)( iMax << ABITS);

    // set saturation
    if (rv == 0)
        rs = 0;
    else
        rs = (short)((k1*chroma)/iMax);

    // set hue
    if (rs == 0)
        rh = 0;
    else {
        if ( ri == iMax ) {
            rh  = (short)( (k2*(6*chroma+gi - bi))/(6*chroma));
            if (rh >= k2) rh -= k2;
        } else if (gi  == iMax)
            rh  = (short)( (k2*(2*chroma+bi - ri ))/(6*chroma));
        else // (bi == iMax )
                    rh  = (short)( (k2*(4*chroma+ri - gi ))/(6*chroma));
    }
    hsv[hsvOff+0] = rv;
    hsv[hsvOff+1] = rs;
    hsv[hsvOff+2] = rh;
}

void hsv2rgb(unsigned short *hsv,int hsvOff, unsigned char *rgb,int rgbOff)
{
    int ABITS = 4;
    int HSCALE = 256;
    int m;
    int H,X,ih,is,iv;
    int k1=255<<ABITS;
    int k2=HSCALE<<ABITS;
    int k3=1<<(ABITS-1);
    int rr=0;
    int rg=0;
    int rb=0;
    short cv = hsv[hsvOff+0];
    short cs = hsv[hsvOff+1];
    short ch = hsv[hsvOff+2];

    // set chroma and min component value m
    //chroma = ( cv * cs )/k1;
    //m = cv - chroma;
    m = ((int)cv*(k1 - (int)cs ))/k1;

    // chroma  == 0 <-> cs == 0 --> m=cv
    if (cs == 0) {
        rb = ( rg = ( rr =( cv >> ABITS) ));
    } else {
        ih=(int)ch;
        is=(int)cs;
        iv=(int)cv;

        H = (6*ih)/k2;
        X = ((iv*is)/k2)*(k2- abs(6*ih- 2*(H>>1)*k2 - k2)) ;

        // removing additional bits --> unit8
        X=( (X+iv*(k1 - is ))/k1 + k3 ) >> ABITS;
        m=m >> ABITS;

        // ( chroma + m ) --> cv ;
        cv=(short) (cv >> ABITS);
        switch (H) {
        case 0:
            rr = cv;
            rg = X;
            rb = m;
            break;
        case 1:
            rr = X;
            rg = cv;
            rb = m;
            break;
        case 2:
            rr = m;
            rg = cv;
            rb = X;
            break;
        case 3:
            rr = m;
            rg = X;
            rb = cv;
            break;
        case 4:
            rr = X;
            rg = m;
            rb = cv;
            break;
        case 5:
            rr = cv;
            rg = m ;
            rb = X;
            break;
        }
    }
    rgb[rgbOff+0] =  rr;
    rgb[rgbOff+1] =  rg;
    rgb[rgbOff+2] =  rb;
}
*/

















vec4 pass2(vec2 vTextureCoord, float xDistance, float yDistance ,vec4 front)
{

	float beta = 1.2;
	vec2 pos = vTextureCoord.st;

	vec3 s00 = texture2D( sTexture, pos + vec2(-xDistance,yDistance) ).rgb;
	vec3 s10 = texture2D( sTexture, pos + vec2(-xDistance,0.0) ).rgb;
	vec3 s20 = texture2D( sTexture, pos + vec2(-xDistance,-yDistance) ).rgb;
	vec3 s01 = texture2D( sTexture, pos + vec2(0.0,yDistance) ).rgb;
	vec3 s21 = texture2D( sTexture, pos + vec2(0.0,-yDistance) ).rgb;
	vec3 s02 = texture2D( sTexture, pos + vec2(xDistance, yDistance) ).rgb;
	vec3 s12 = texture2D( sTexture, pos + vec2(xDistance, 0.0) ).rgb;
	vec3 s22 = texture2D( sTexture, pos + vec2(xDistance, -yDistance) ).rgb;

/*
	s00.rgb = s00.rgb - 1.0*(s00.rgb-1.0)*(s00.rgb-1.0);
	s10.rgb = s10.rgb - 1.0*(s10.rgb-1.0)*(s10.rgb-1.0);
	s20.rgb = s20.rgb - 1.0*(s20.rgb-1.0)*(s20.rgb-1.0);
	s01.rgb = s01.rgb - 1.0*(s01.rgb-1.0)*(s01.rgb-1.0);
	s21.rgb = s21.rgb - 1.0*(s21.rgb-1.0)*(s21.rgb-1.0);
	s02.rgb = s02.rgb - 1.0*(s02.rgb-1.0)*(s02.rgb-1.0);
	s12.rgb = s12.rgb - 1.0*(s12.rgb-1.0)*(s12.rgb-1.0);
	s22.rgb = s22.rgb - 1.0*(s22.rgb-1.0)*(s22.rgb-1.0);


	float sx_r = s00.r + 1.0 * s10.r + s20.r - (s02.r + 1.0 * s12.r + s22.r);
	float sx_g = s00.g + 1.0 * s10.g + s20.g - (s02.g + 1.0 * s12.g + s22.g);
	float sx_b = s00.b + 1.0 * s10.b + s20.b - (s02.b + 1.0 * s12.b + s22.b);

	float sy_r = s00.r + 1.0 * s01.r + s02.r - (s20.r + 1.0 * s21.r + s22.r);
	float sy_g = s00.g + 1.0 * s01.g + s02.g - (s20.g + 1.0 * s21.g + s22.g);
	float sy_b = s00.b + 1.0 * s01.b + s02.b - (s20.b + 1.0 * s21.b + s22.b);

*/


	float sx_r = s00.r + 1.0 * s10.r + s20.r - (s02.r + 1.0 * s12.r + s22.r);
	float sx_g = s00.g + 1.0 * s10.g + s20.g - (s02.g + 1.0 * s12.g + s22.g);
	float sx_b = s00.b + 1.0 * s10.b + s20.b - (s02.b + 1.0 * s12.b + s22.b);

	float sy_r = s00.r + 1.0 * s01.r + s02.r - (s20.r + 1.0 * s21.r + s22.r);
	float sy_g = s00.g + 1.0 * s01.g + s02.g - (s20.g + 1.0 * s21.g + s22.g);
	float sy_b = s00.b + 1.0 * s01.b + s02.b - (s20.b + 1.0 * s21.b + s22.b);

	 vec3 color ;
	 color.r = sqrt(sx_r * sx_r + sy_r * sy_r);
	 color.g = sqrt(sx_g * sx_g + sy_g * sy_g );
	 color.b = sqrt(sx_b * sx_b + sy_b * sy_b);
     float  max_v = 500.0/255.0 ;
     float  min_v = 0.0/255.0 ;



	 color.rgb  = min(color.rgb, max_v);
 	 color.rgb  = max(color.rgb, min_v);


     color.r = 1.0*(color.r -min_v) / (max_v - min_v) ;
     color.g = 1.0*(color.g -min_v) / (max_v - min_v) ;
     color.b = 1.0*(color.b -min_v) / (max_v - min_v) ;


/*
     float  color_Y = 0.299*color.r  + 0.587 *color.g + 0.114*color.b ;
     color.r = exp(-5.0*pow(color.r ,beta) );
     color.g = exp(-5.0*pow(color.g ,beta) );
     color.b = exp(-5.0*pow(color.b ,beta) );


     vec3 srgb = texture2D( sTexture, pos).rgb;

      if( srgb.r<=0.5) color.r = color.r *srgb.r/0.5;
      else  color.r = 1.0- (1.0-color.r) *(1.0-srgb.r)/0.5;

      if( srgb.g<=0.5) color.g = color.g *srgb.g/0.5;
      else  color.g = 1.0- (1.0-color.g) *(1.0-srgb.g)/0.5;

      if( srgb.b<=0.5) color.b = color.b *srgb.b/0.5;
      else  color.b = 1.0- (1.0-color.b) *(1.0-srgb.b)/0.5;

*/

      /*******RGB2LAB 空间 ********/
  /*    vec3 colorLAB ;
      colorLAB.r = 0.2126007 * color.r +0.7151947 * color.g + 0.0722046 *color.b;
      colorLAB.g = 0.3258962 * color.r -0.4992596 * color.g + 0.1733409 *color.b  +0.5;
      colorLAB.b = 0.1218128 * color.r +0.3785610 * color.g - 0.5003738 *color.b  +0.5;




*/

      /*******LAB2RGB 空间 ********/
  /*    vec3 colorT ;
      float L1 =116.0*colorLAB.r/100.0 -16.0/255.0 ;
      float a1 =(colorLAB.g-0.5)*174.0 ;
      float b1 =(colorLAB.b-0.5)*410.0;


      colorT.r = L1 + 0.0120308 * a1 + 0.0021207* b1 ;
      colorT.g = L1 - 0.0035973 * a1 - 0.0001765* b1 ;
      colorT.b = L1 + 0.0002074 * a1 - 0.0044965* b1 ;


     //	color.r = 1.0- (1.0-color.r) *(1.0-srgb.r)/0.5;
     //	color.g = 1.0- (1.0-color.g) *(1.0-srgb.g)/0.5;
     //	color.b = 1.0- (1.0-color.b) *(1.0-srgb.b)/0.5;

	 color.rgb  = min(colorT.rgb, 1.0);
 	 color.rgb  = max(colorT.rgb, 0.0);

*/

	//vec3 colorout ;
	//colorout.rgb = 1.0*(1.0-color.rgb)*(texture2D( sTexture, pos).rgb);
    return vec4(color.rgb ,1.0);

}




vec4 test6(vec2 vTextureCoord, float xDistance, float yDistance ,vec4 front)
{
/*
	vec2 pos = vTextureCoord.st;

	vec4 color  = texture2D( sTexture, pos );;




	//	color.b = 1.0-(1.0-color.b )*((1.0-color.b ));
	//	color.g = 1.0-(1.0-color.g )*((1.0-color.g ));
	//	color.r = 1.0-(1.0-color.r )*((1.0-color.r));
				 //B1-2*B1*(B1-0.5)*(B1-1)
	    color.b = color.b - 1.0* color.b*(color.b-0.5 )*((color.b -1.0));
		color.g = color.g - 1.0* color.g*(color.g-0.5 )*((color.g -1.0));
		color.r = color.r + 1.0* color.r*(color.r-0.5 )*((color.r -1.0));


		color.rgb = min(color.rgb, 1.0);
		color.rgb = max(color.rgb, 0.0);

		if(front.r <0.5)
			color.r = color.r + (2.0* front.r - 1.0 )*( color.r- color.r* color.r );
		else color.r = color.r + (2.0* front.r - 1.0 )*( sqrt(color.r)- color.r );

		if(front.g <0.5)
			color.g = color.g + (2.0* front.g - 1.0 )*( color.g- color.g* color.g );
		else color.g = color.g + (2.0* front.g - 1.0 )*( sqrt(color.g)- color.g );

		if(front.b <0.5)
			color.b = color.b + (2.0* front.b - 1.0 )*( color.b- color.b* color.b );
		else color.b = color.b + (2.0* front.b - 1.0 )*( sqrt(color.b)- color.b );

		 color.r=1.0 - exp(-5.0*pow(color.r,1.75));
		 color.g=1.0 - exp(-5.0*pow(color.g,1.75));
		 color.b=1.0 - exp(-5.0*pow(color.b,1.75));

		vec3 new_color ;
		new_color = min(color.rgb, 1.0);
		new_color = max(color.rgb, 0.0);



*/


	///*日系

	vec4 color = texture2D(sTexture, vTextureCoord);

		 vec3 new_color = color.rgb;


		 if( color.r < 1.0/3.0)
		 {
			 color.r = (((1.0/3.0) - 30.0/255.0)/(1.0/3.0))*color.r +30.0/255.0 ;
		 }
		 else if(color.r > 2.0/3.0 )
			 color.r= (((1.0/3.0) - 30.0/255.0)/(1.0/3.0))*(color.r-2.0/3.0) +2.0/3.0 ;

		 if( color.g < 1.0/3.0)
		 {
			 color.g = (((1.0/3.0) - 30.0/255.0)/(1.0/3.0))*color.g +30.0/255.0 ;
		 }
		 else if(color.g > 2.0/3.0 )
			 color.g= (((1.0/3.0) - 30.0/255.0)/(1.0/3.0))*(color.g-2.0/3.0) +2.0/3.0 ;


		 if( color.b < 1.0/3.0)
		 {
			 color.b = (((1.0/3.0) - 30.0/255.0)/(1.0/3.0))*color.b +30.0/255.0 ;
		 }
		 else if(color.b > 2.0/3.0 )
			 color.b= (((1.0/3.0) - 30.0/255.0)/(1.0/3.0))*(color.b-2.0/3.0) +2.0/3.0 ;




		 new_color.r =  255.0/(255.0-20.0) * (color.r - 20.0/255.0) ;
		 new_color.g =  255.0/(255.0-0.0) * (color.g - 0.0/255.0) ;
		 new_color.b =  color.b ;
		// color.rgb = min(color.rgb, 1.0);
		 new_color.rgb = max(new_color.rgb, 0.0);


		 color.r= (1.0 - exp(-5.0*pow(new_color.r,1.75))) *0.75 + 0.25 *new_color.r;
		 color.g=(1.0 - exp(-5.0*pow(new_color.g,1.75))) *0.75 + 0.25 *new_color.g;
		 color.b=(1.0 - exp(-5.0*pow(new_color.b,1.75))) *0.75 + 0.25 *new_color.b;
		 //B1-1.25*B1*B2*(B1-1)
		//new_color.r= new_color.r -1.25 * new_color.r *new_color.r *(new_color.r-1.0);
		//new_color.g= new_color.g -1.25 * new_color.g *new_color.g *(new_color.g-1.0);
		//new_color.b= new_color.b -1.25 * new_color.b *new_color.b *(new_color.b-1.0);

//柔光模式
			if(front.r <0.5)
				new_color.r = color.r + (2.0* front.r - 1.0 )*( color.r- color.r* color.r );
			else new_color.r = color.r + (2.0* front.r - 1.0 )*( sqrt(color.r)- color.r );

			if(front.g <0.5)
				new_color.g = color.g + (2.0* front.g - 1.0 )*( color.g- color.g* color.g );
			else new_color.g = color.g + (2.0* front.g - 1.0 )*( sqrt(color.g)- color.g );

			if(front.b <0.5)
				new_color.b = color.b + (2.0* front.b - 1.0 )*( color.b- color.b* color.b );
			else new_color.b = color.b + (2.0* front.b - 1.0 )*( sqrt(color.b)- color.b );







	  //日系  end





/* 唯美
	vec4 color = texture2D(sTexture, vTextureCoord);

			 vec3 new_color = color.rgb;


			 if( color.r < 1.0/3.0)
			 {
				 color.r = (((1.0/3.0) - 30.0/255.0)/(1.0/3.0))*color.r +30.0/255.0 ;
			 }
			 else if(color.r > 2.0/3.0 )
				 color.r= (((1.0/3.0) - 30.0/255.0)/(1.0/3.0))*(color.r-2.0/3.0) +2.0/3.0 ;

			 if( color.g < 1.0/3.0)
			 {
				 color.g = (((1.0/3.0) - 30.0/255.0)/(1.0/3.0))*color.g +30.0/255.0 ;
			 }
			 else if(color.g > 2.0/3.0 )
				 color.g= (((1.0/3.0) - 30.0/255.0)/(1.0/3.0))*(color.g-2.0/3.0) +2.0/3.0 ;


			 if( color.b < 1.0/3.0)
			 {
				 color.b = (((1.0/3.0) - 30.0/255.0)/(1.0/3.0))*color.b +30.0/255.0 ;
			 }
			 else if(color.b > 2.0/3.0 )
				 color.b= (((1.0/3.0) - 30.0/255.0)/(1.0/3.0))*(color.b-2.0/3.0) +2.0/3.0 ;




			 new_color.r =  color.r  ;
			 new_color.g =  color.g  ;
			 new_color.b = (200.0 - 20.0)/255.0 *  color.b + 20.0/255.0  ;


			 new_color.r=1.0 - exp(-5.0*pow(new_color.r,1.75));
			 new_color.g=1.0 - exp(-5.0*pow(new_color.g,1.75));
			 new_color.b=1.0 - exp(-5.0*pow(new_color.b,1.75));







*/


		 color.rgb = min(new_color.rgb, 1.0);
		 color.rgb = max(new_color.rgb, 0.0);

	 return color;
}



void main() {
	float xDistance = 1.0 / height;
	float yDistance = 1.0 / width;

	vec4 front = texture2D(uFrontTexture, vAreaEffectTextureCoord);

	vec4 color = test6(vTextureCoord, xDistance, yDistance,front);

	gl_FragColor = vec4(color.r, color.g, color.b, color.a);

}








