#extension GL_OES_EGL_image_external : require
precision mediump float;
varying vec2 vTextureCoord;
uniform samplerExternalOES sTexture;
uniform float width;
uniform float height;
uniform float scale;


void main() {


	const float m_pi_2 = 1.570963;
	float radius_offset = 1.08 ;
	float coord_offset_x = 1.08 ;
	float coord_offset_y = 1.08 ;
	float newcoord_offset_x = 0.90 ;
	float newcoord_offset_y = 1.15 ;

	if(width/height <1080.0/1440.0-0.10)
	{	 radius_offset = 1.15  ;
		 coord_offset_x = 1.35 ;
	     coord_offset_y = 1.00* sqrt(width/height) ;
		 newcoord_offset_x = 1.10 ;//1.100 ;
		 newcoord_offset_y = 1.25 ; //1.2
	}
	float alpha = scale * 2.0 + 0.075;
	float bound2 = 0.25 * (1.0 + width * width / (height * height));
	float bound = sqrt(bound2);
	float radius = radius_offset * bound;
	float radius2 = radius * radius;
	float max_radian = m_pi_2 - atan(alpha * sqrt(radius2 - bound2), bound);
	float factor = bound / max_radian;

	vec2 coord = vTextureCoord - vec2(0.5, 0.5);
	highp vec2 scaled_coord ;
	scaled_coord.x= coord.x * scale*coord_offset_x;
	scaled_coord.y= coord.y * scale*coord_offset_y;
	float dist = length(scaled_coord);
	float radian = m_pi_2 - atan(alpha * sqrt(radius2 - dist * dist), dist);
	float scalar = radian * factor / dist;

	vec2 new_coord ;
	new_coord.x = coord.x * scalar*1.0/newcoord_offset_x + 0.5;
	new_coord.y = coord.y * scalar*1.0/newcoord_offset_y + 0.5;

	gl_FragColor = texture2D(sTexture, new_coord);
  //gl_FragColor = vec4(1.0, 0.0, 0.0, 1.0);
}
